
-- -----------------------------------------------------------------
-- System Generator version 7.1.01 vhdl source file.
-- 
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
-- 
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
-- 
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
-- 
-- Any modifications that are made to source code are done at the users
-- sole risk and will be unsupported.
-- 
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
-- -----------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

entity jtagcosim_top is 
  port (
    ac97_sdata_in: in std_logic;
    ac97_synch: in std_logic;
    beep_tone_in: in std_logic;
    pushbuttons: in std_logic_vector(4 downto 0);
    switches: in std_logic_vector(3 downto 0);
    sys_clk: in std_logic;
    vga_out_blue: in std_logic_vector(7 downto 0);
    ac97_bit_clock: out std_logic;
    ac97_sdata_out: out std_logic;
    audio_reset_z: out std_logic;
    led: out std_logic_vector(3 downto 0);
    vga_comp_synch: out std_logic;
    vga_hsynch: out std_logic;
    vga_out_blank_z: out std_logic;
    vga_out_green: out std_logic_vector(7 downto 0);
    vga_out_pixel_clock: out std_logic;
    vga_out_red: out std_logic_vector(7 downto 0);
    vga_vsynch: out std_logic
  );
end jtagcosim_top;

architecture structural of jtagcosim_top is
  attribute syn_noprune: boolean;

  component bufgmux
    port (
      i0: in std_ulogic;
      i1: in std_ulogic;
      s: in std_ulogic;
      o: out std_ulogic
    );
  end component;
  component ibufg
    port (
      i: in std_ulogic;
      o: out std_ulogic
    );
  end component;
  component jtagcosim_iface_virtex2
    port (
      data_out: in std_logic_vector (31 downto 0);
      sys_clk: in std_logic;
      addr: out std_logic_vector (23 downto 0);
      cosim_clk_sel: out std_logic;
      data_in: out std_logic_vector (31 downto 0);
      sstep_clk: out std_logic;
      we: out std_logic
    );
  end component;
  component sysgen_hw_cosim_interface
    port (
      ac97_sdata_in: in std_logic;
      ac97_synch: in std_logic;
      addr: in std_logic_vector (23 downto 0);
      bank_sel: in std_logic_vector (7 downto 0);
      beep_tone_in: in std_logic;
      clk: in std_logic;
      data_in: in std_logic_vector (31 downto 0);
      pci_clk: in std_logic;
      pushbuttons: in std_logic_vector(4 downto 0);
      re: in std_logic;
      switches: in std_logic_vector(3 downto 0);
      vga_out_blue: in std_logic_vector(7 downto 0);
      we: in std_logic;
      ac97_bit_clock: out std_logic;
      ac97_sdata_out: out std_logic;
      audio_reset_z: out std_logic;
      data_out: out std_logic_vector (31 downto 0);
      led: out std_logic_vector(3 downto 0);
      vga_comp_synch: out std_logic;
      vga_hsynch: out std_logic;
      vga_out_blank_z: out std_logic;
      vga_out_green: out std_logic_vector(7 downto 0);
      vga_out_pixel_clock: out std_logic;
      vga_out_red: out std_logic_vector(7 downto 0);
      vga_vsynch: out std_logic
    );
  end component;

  attribute syn_noprune of jtagcosim_iface_virtex2: component is true;
  attribute syn_noprune of sysgen_hw_cosim_interface: component is true;

  signal ac97_bit_clock_x_0: std_logic;
  signal ac97_sdata_in_x_0: std_logic;
  signal ac97_sdata_out_x_0: std_logic;
  signal ac97_synch_x_0: std_logic;
  signal addr: std_logic_vector (23 downto 0);
  signal audio_reset_z_x_0: std_logic;
  signal beep_tone_in_x_0: std_logic;
  signal clk_ibufg_in: std_logic;
  signal clk_ibufg_out: std_logic;
  signal cosim_clk: std_logic;
  signal cosim_clk_sel: std_logic;
  signal data_in: std_logic_vector (31 downto 0);
  signal data_out: std_logic_vector (31 downto 0);
  signal led_x_0: std_logic_vector(3 downto 0);
  signal pushbuttons_x_0: std_logic_vector(4 downto 0);
  signal sstep_clk: std_logic;
  signal switches_x_0: std_logic_vector(3 downto 0);
  signal sys_clk_buf: std_logic;
  signal vga_comp_synch_x_0: std_logic;
  signal vga_hsynch_x_0: std_logic;
  signal vga_out_blank_z_x_0: std_logic;
  signal vga_out_blue_x_0: std_logic_vector(7 downto 0);
  signal vga_out_green_x_0: std_logic_vector(7 downto 0);
  signal vga_out_pixel_clock_x_0: std_logic;
  signal vga_out_red_x_0: std_logic_vector(7 downto 0);
  signal vga_vsynch_x_0: std_logic;
  signal we: std_logic;

begin
  ac97_sdata_in_x_0 <= ac97_sdata_in;
  ac97_synch_x_0 <= ac97_synch;
  beep_tone_in_x_0 <= beep_tone_in;
  pushbuttons_x_0 <= pushbuttons;
  switches_x_0 <= switches;
  clk_ibufg_in <= sys_clk;
  vga_out_blue_x_0 <= vga_out_blue;
  ac97_bit_clock <= ac97_bit_clock_x_0;
  ac97_sdata_out <= ac97_sdata_out_x_0;
  audio_reset_z <= audio_reset_z_x_0;
  led <= led_x_0;
  vga_comp_synch <= vga_comp_synch_x_0;
  vga_hsynch <= vga_hsynch_x_0;
  vga_out_blank_z <= vga_out_blank_z_x_0;
  vga_out_green <= vga_out_green_x_0;
  vga_out_pixel_clock <= vga_out_pixel_clock_x_0;
  vga_out_red <= vga_out_red_x_0;
  vga_vsynch <= vga_vsynch_x_0;

  bufgmux_comp1: bufgmux
    port map (
      i0 => clk_ibufg_out,
      i1 => sstep_clk,
      s => '0',
      o => sys_clk_buf
    );
  bufgmux_comp2: bufgmux
    port map (
      i0 => sstep_clk,
      i1 => clk_ibufg_out,
      s => cosim_clk_sel,
      o => cosim_clk
    );
  hwcosimtoplevel: sysgen_hw_cosim_interface
    port map (
      ac97_sdata_in => ac97_sdata_in_x_0,
      ac97_synch => ac97_synch_x_0,
      addr => addr,
      bank_sel => "00000000",
      beep_tone_in => beep_tone_in_x_0,
      clk => cosim_clk,
      data_in => data_in,
      pci_clk => sys_clk_buf,
      pushbuttons => pushbuttons_x_0,
      re => '0',
      switches => switches_x_0,
      vga_out_blue => vga_out_blue_x_0,
      we => we,
      ac97_bit_clock => ac97_bit_clock_x_0,
      ac97_sdata_out => ac97_sdata_out_x_0,
      audio_reset_z => audio_reset_z_x_0,
      data_out => data_out,
      led => led_x_0,
      vga_comp_synch => vga_comp_synch_x_0,
      vga_hsynch => vga_hsynch_x_0,
      vga_out_blank_z => vga_out_blank_z_x_0,
      vga_out_green => vga_out_green_x_0,
      vga_out_pixel_clock => vga_out_pixel_clock_x_0,
      vga_out_red => vga_out_red_x_0,
      vga_vsynch => vga_vsynch_x_0
    );
  ibufg_comp: ibufg
    port map (
      i => clk_ibufg_in,
      o => clk_ibufg_out
    );
  jtag_iface: jtagcosim_iface_virtex2
    port map (
      data_out => data_out,
      sys_clk => sys_clk_buf,
      addr => addr,
      cosim_clk_sel => cosim_clk_sel,
      data_in => data_in,
      sstep_clk => sstep_clk,
      we => we
    );
end structural;
