
-- -----------------------------------------------------------------
-- System Generator version 7.1.01 vhdl source file.
-- 
-- Copyright(C) 2005 by Xilinx, Inc.  All rights reserved.  This
-- text/file contains proprietary, confidential information of Xilinx,
-- Inc., is distributed under license from Xilinx, Inc., and may be used,
-- copied and/or disclosed only pursuant to the terms of a valid license
-- agreement with Xilinx, Inc.  Xilinx hereby grants you a license to use
-- this text/file solely for design, simulation, implementation and
-- creation of design files limited to Xilinx devices or technologies.
-- Use with non-Xilinx devices or technologies is expressly prohibited
-- and immediately terminates your license unless covered by a separate
-- agreement.
-- 
-- Xilinx is providing this design, code, or information "as is" solely
-- for use in developing programs and solutions for Xilinx devices.  By
-- providing this design, code, or information as one possible
-- implementation of this feature, application or standard, Xilinx is
-- making no representation that this implementation is free from any
-- claims of infringement.  You are responsible for obtaining any rights
-- you may require for your implementation.  Xilinx expressly disclaims
-- any warranty whatsoever with respect to the adequacy of the
-- implementation, including but not limited to warranties of
-- merchantability or fitness for a particular purpose.
-- 
-- Xilinx products are not intended for use in life support appliances,
-- devices, or systems.  Use in such applications is expressly prohibited.
-- 
-- Any modifications that are made to source code are done at the users
-- sole risk and will be unsupported.
-- 
-- This copyright and support notice must be retained as part of this
-- text at all times.  (c) Copyright 1995-2005 Xilinx, Inc. 
-- All rights reserved.
-- -----------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;
use work.clock_pkg.all;

entity sysgen_hw_cosim_interface is 
  port (
    ac97_sdata_in: in std_logic;
    ac97_synch: in std_logic;
    addr: in std_logic_vector (23 downto 0);
    bank_sel: in std_logic_vector (7 downto 0);
    beep_tone_in: in std_logic;
    clk: in std_logic;
    data_in: in std_logic_vector (31 downto 0);
    pci_clk: in std_logic;
    pushbuttons: in std_logic_vector(4 downto 0);
    re: in std_logic;
    switches: in std_logic_vector(3 downto 0);
    vga_out_blue: in std_logic_vector(7 downto 0);
    we: in std_logic;
    ac97_bit_clock: out std_logic;
    ac97_sdata_out: out std_logic;
    audio_reset_z: out std_logic;
    data_out: out std_logic_vector (31 downto 0);
    led: out std_logic_vector(3 downto 0);
    vga_comp_synch: out std_logic;
    vga_hsynch: out std_logic;
    vga_out_blank_z: out std_logic;
    vga_out_green: out std_logic_vector(7 downto 0);
    vga_out_pixel_clock: out std_logic;
    vga_out_red: out std_logic_vector(7 downto 0);
    vga_vsynch: out std_logic
  );
end sysgen_hw_cosim_interface;

architecture structural of sysgen_hw_cosim_interface is
  component bandpass_filter_hw_clk_wrapper
    port (
      ce: in std_logic := '1';
      ce_clr: in std_logic := '0';
      clk: in std_logic;
      gateway_in: in std_logic_vector(7 downto 0);
      gateway_out: out std_logic_vector(7 downto 0)
    );
  end component;
  component xlmemmap
    generic (
      bank_sel_arith: integer := xlUnsigned;
      bank_sel_bin_pt: integer := 0;
      bank_sel_width: integer := 8;
      addr_arith: integer := xlUnsigned;
      addr_bin_pt: integer := 0;
      addr_width: integer := 24;
      data_in_arith: integer := xlUnsigned;
      data_in_bin_pt: integer := 0;
      data_in_width: integer := 32;
      data_out_arith: integer := xlUnsigned;
      data_out_bin_pt: integer := 0;
      data_out_width: integer := 32;
      mm_gateway_in_arith: integer := xlSigned;
      mm_gateway_in_bin_pt: integer := 6;
      mm_gateway_in_width: integer := 8;
      mm_gateway_out_arith: integer := xlSigned;
      mm_gateway_out_bin_pt: integer := 6;
      mm_gateway_out_width: integer := 8
    );
    port (
      addr: in std_logic_vector (addr_width - 1 downto 0);
      bank_sel: in std_logic_vector (bank_sel_width - 1 downto 0);
      data_in: in std_logic_vector (data_in_width - 1 downto 0);
      mm_gateway_out: in std_logic_vector (mm_gateway_out_width - 1 downto 0);
      pci_clk: in std_logic;
      re: in std_logic;
      we: in std_logic;
      data_out: out std_logic_vector (data_out_width - 1 downto 0);
      mm_gateway_in: out std_logic_vector (mm_gateway_in_width - 1 downto 0)
    );
  end component;

  signal addr_x_0: std_logic_vector (23 downto 0);
  signal bank_sel_x_0: std_logic_vector (7 downto 0);
  signal clk_x_0: std_logic;
  signal data_in_x_0: std_logic_vector (31 downto 0);
  signal data_out_x_0: std_logic_vector (31 downto 0);
  signal gateway_in: std_logic_vector(7 downto 0);
  signal gateway_out: std_logic_vector(7 downto 0);
  signal pci_clk_x_0: std_logic;
  signal re_x_0: std_logic;
  signal we_x_0: std_logic;

begin
  addr_x_0 <= addr;
  bank_sel_x_0 <= bank_sel;
  clk_x_0 <= clk;
  data_in_x_0 <= data_in;
  pci_clk_x_0 <= pci_clk;
  re_x_0 <= re;
  we_x_0 <= we;
  ac97_bit_clock <= 'Z';
  ac97_sdata_out <= 'Z';
  audio_reset_z <= 'Z';
  data_out <= data_out_x_0;
  led <= (others => 'Z');
  vga_comp_synch <= 'Z';
  vga_hsynch <= 'Z';
  vga_out_blank_z <= 'Z';
  vga_out_green <= (others => 'Z');
  vga_out_pixel_clock <= 'Z';
  vga_out_red <= (others => 'Z');
  vga_vsynch <= 'Z';

  usertoplevel: bandpass_filter_hw_clk_wrapper
    port map (
      ce => '1',
      ce_clr => '0',
      clk => clk_x_0,
      gateway_in => gateway_in,
      gateway_out => gateway_out
    );
  xlmemmap_x_0: xlmemmap
    generic map (
      bank_sel_arith => xlUnsigned,
      bank_sel_bin_pt => 0,
      bank_sel_width => 8,
      addr_arith => xlUnsigned,
      addr_bin_pt => 0,
      addr_width => 24,
      data_in_arith => xlUnsigned,
      data_in_bin_pt => 0,
      data_in_width => 32,
      data_out_arith => xlUnsigned,
      data_out_bin_pt => 0,
      data_out_width => 32,
      mm_gateway_in_arith => xlSigned,
      mm_gateway_in_bin_pt => 6,
      mm_gateway_in_width => 8,
      mm_gateway_out_arith => xlSigned,
      mm_gateway_out_bin_pt => 6,
      mm_gateway_out_width => 8
    )
    port map (
      addr => addr_x_0,
      bank_sel => bank_sel_x_0,
      data_in => data_in_x_0,
      mm_gateway_out => gateway_out,
      pci_clk => pci_clk_x_0,
      re => re_x_0,
      we => we_x_0,
      data_out => data_out_x_0,
      mm_gateway_in => gateway_in
    );
end structural;
